'use strict';


var message = {},
  wrapper = {},
  buttonNewPhoto = {},
  buttonDownload = {},
  video = {},
  canvas = {};



$(document).ready(function () {

    
    getdataheader();

});


let pubequid = "";
let pubinspectionid = "";
let pubtype = "";


function getdataheader() {
    

    let str_para = getUrlVars()["para"];
    //let Base64 = { _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=", encode: function (e) { var t = ""; var n, r, i, s, o, u, a; var f = 0; e = Base64._utf8_encode(e); while (f < e.length) { n = e.charCodeAt(f++); r = e.charCodeAt(f++); i = e.charCodeAt(f++); s = n >> 2; o = (n & 3) << 4 | r >> 4; u = (r & 15) << 2 | i >> 6; a = i & 63; if (isNaN(r)) { u = a = 64 } else if (isNaN(i)) { a = 64 } t = t + this._keyStr.charAt(s) + this._keyStr.charAt(o) + this._keyStr.charAt(u) + this._keyStr.charAt(a) } return t }, decode: function (e) { var t = ""; var n, r, i; var s, o, u, a; var f = 0; e = e.replace(/[^A-Za-z0-9+/=]/g, ""); while (f < e.length) { s = this._keyStr.indexOf(e.charAt(f++)); o = this._keyStr.indexOf(e.charAt(f++)); u = this._keyStr.indexOf(e.charAt(f++)); a = this._keyStr.indexOf(e.charAt(f++)); n = s << 2 | o >> 4; r = (o & 15) << 4 | u >> 2; i = (u & 3) << 6 | a; t = t + String.fromCharCode(n); if (u != 64) { t = t + String.fromCharCode(r) } if (a != 64) { t = t + String.fromCharCode(i) } } t = Base64._utf8_decode(t); return t }, _utf8_encode: function (e) { e = e.replace(/rn/g, "n"); var t = ""; for (var n = 0; n < e.length; n++) { var r = e.charCodeAt(n); if (r < 128) { t += String.fromCharCode(r) } else if (r > 127 && r < 2048) { t += String.fromCharCode(r >> 6 | 192); t += String.fromCharCode(r & 63 | 128) } else { t += String.fromCharCode(r >> 12 | 224); t += String.fromCharCode(r >> 6 & 63 | 128); t += String.fromCharCode(r & 63 | 128) } } return t }, _utf8_decode: function (e) { var t = ""; var n = 0; var r = c1 = c2 = 0; while (n < e.length) { r = e.charCodeAt(n); if (r < 128) { t += String.fromCharCode(r); n++ } else if (r > 191 && r < 224) { c2 = e.charCodeAt(n + 1); t += String.fromCharCode((r & 31) << 6 | c2 & 63); n += 2 } else { c2 = e.charCodeAt(n + 1); c3 = e.charCodeAt(n + 2); t += String.fromCharCode((r & 15) << 12 | (c2 & 63) << 6 | c3 & 63); n += 3 } } return t } }
    //let de_para = Base64.decode(str_para);
 
    if (str_para.indexOf("|") != -1) {
        let arr_para = str_para.split('|');

        pubequid = arr_para[0];
        pubinspectionid = arr_para[1];
        pubtype = arr_para[2];


    }    


}

function initElement() {
    message = document.getElementById('msg');
    wrapper = document.getElementById('wrapper');
    buttonNewPhoto = document.getElementById('newphoto');
    //buttonDownload = document.getElementById('download');
    video = document.querySelector('video');
    canvas = document.querySelector('canvas');

    if (navigator.mediaDevices === undefined) {
        navigator.mediaDevices = {};
    }

    if (navigator.mediaDevices.getUserMedia === undefined) {
        navigator.mediaDevices.getUserMedia = function (constraints) {

            var getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;

            if (!getUserMedia) {
                return Promise.reject(new Error('getUserMedia is not implemented in this browser'));
            }

            return new Promise(function (resolve, reject) {
                getUserMedia.call(navigator, constraints, resolve, reject);
            })
        }
    }
}

function onTakeAPhoto() {

    canvas.getContext('2d').drawImage(video, 0, 0, video.width, video.height);

    setTimeout(function () {
        let base64Canvas = canvas.toDataURL("image/jpeg").split(';base64,')[1];
        base64Canvas = base64Canvas.replace(/\+/g, " ").replace(/=/,"sys*");
        let xhr = new XMLHttpRequest();
        xhr.onload = function () {
            if (this.status == 200) {
                let result = document.getElementById('result-pic');
                console.log('this is the response:' + this.response);
                result.src = this.response;
            }
        }
        xhr.open('POST', 'saveimage.aspx', true);
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xhr.send('image=' + base64Canvas + "*" + pubequid + "*" + pubinspectionid + "*" + pubtype);



        //canvas.toBlob(function (blob) {
        //    var link = document.createElement('a');
        //    link.download = 'photo.jpg';
        //    link.setAttribute('href', URL.createObjectURL(blob));
        //    link.dispatchEvent(new MouseEvent('click'));

        //}, 'image/jpeg', 1);
    }, 500);



    setTimeout(function () {
        window.close();
    }, 1000);


    //buttonDownload.removeAttribute('disabled');

}

function onDownloadPhoto() {
    canvas.toBlob(function (blob) {
        var link = document.createElement('a');
        link.download = 'photo.jpg';
        link.setAttribute('href', URL.createObjectURL(blob));
        link.dispatchEvent(new MouseEvent('click'));

    }, 'image/jpeg', 1);
}

function onLoadVideo() {
    video.setAttribute('width', this.videoWidth);
    video.setAttribute('height', this.videoHeight);
    canvas.setAttribute('width', this.videoWidth);
    canvas.setAttribute('height', this.videoHeight);
    video.play();
}

function onMediaStream(stream) {
    if ('srcObject' in video) {
        video.srcObject = stream;
    } else {
        video.src = window.URL.createObjectURL(stream);
    }

    message.style.display = 'none';
    wrapper.style.display = 'block';
    buttonNewPhoto.addEventListener('click', onTakeAPhoto);
    //buttonDownload.addEventListener('click', onDownloadPhoto);
    video.addEventListener('loadedmetadata', onLoadVideo);
}

function onMediaError(err) {
    message.innerHTML = err.name + ': ' + err.message;
}

function initEvent() {
    navigator.mediaDevices
      .getUserMedia({ video: true })
      .then(onMediaStream)
      .catch(onMediaError);
}

function init() {
    initElement();
    initEvent();
}


function getUrlVars() {
    var vars = [], hash;
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
    for (var i = 0; i < hashes.length; i++) {
        hash = hashes[i].split('=');
        vars.push(hash[0]);
        vars[hash[0]] = hash[1];

    }



    return vars;
}


if (window.location.protocol != 'https:' && window.location.protocol != 'file:' && window.location.protocol != 'http:') {
    window.location.href = 'https:' + window.location.href.substring(window.location.protocol.length);
}

window.addEventListener('DOMContentLoaded', init);